"""
    schemas: Autonomy related data with Autonomy Engine metadata,
    configurations and default instructions
"""

autonomy_schema = {
    "type": "object",
    "properties": {
        "message_type": {
            "type": "string",
            "description": "Type of message",
            "example": "autonomy",
            "enum": ["autonomy"],
        },
        "planning_config_ID": {
            "type": "integer",
            "description": "Unique identifier of autonomy engine's planning config ID"
            + " configuration plan",
            "example": 3,
        },
        "version": {
            "type": "string",
            "description": "Version of autonomy engine for given planning config ID",
            "example": "v1.0.0",
        },
        "state": {
            "type": "string",
            "enum": ["start", "stop"],
            "description": "Autonomy engine instruction to start or stop model",
            "example": "stop",
        },
    },
    "required": ["message_type", "planning_config_ID"],
}
